#include "Screen.H"

Char Screen::keymap(int *key) {
	Char
		c;

	if ((key[0] >= 0x01) && (key[0] <= 0x1A)) {
		if (key[0] == 0x09) {
			c=0x09;
			return c;
		}
		c='a' + (key[0] - 0x01);
		c.setControl();
		if (key[0] == 0x08) {
			c.setBksp();
		}
		else if (key[0] == 0x0A) {
			c.setEnter();
		}
		return c;
	}
	switch (key[0]) {
		case 0x7F:
			c.setBksp();
			return c;
		case 0x1B:
			switch (key[1]) {
				case 0x0:
					c.setEsc();
					return c;
				case 0x4F:								// 0x1B
					switch (key[2]) {
						case 0x50:						// 0x1B 0x4F
							c.setF1();	
							return c;
						case 0x51:						// 0x1B 0x4F
							c.setF2();	
							return c;
						case 0x52:						// 0x1B 0x4F
							c.setF3();	
							return c;
						case 0x53:						// 0x1B 0x4F
							c.setF4();	
							return c;
						case 0x61:						// 0x1B 0x4F
							c.setUpArrow();	
							c.setControl();
							return c;
						case 0x62:						// 0x1B 0x4F
							c.setDownArrow();	
							c.setControl();
							return c;
						case 0x63:						// 0x1B 0x4F
							c.setRightArrow();	
							c.setControl();
							return c;
						case 0x64:						// 0x1B 0x4F
							c.setLeftArrow();	
							c.setControl();
							return c;
					}
				case 0x5B:								// 0x1B
					switch (key[2]) {
						case 0x0:
							c.setUnknown();
							return c;
						case 0x31:						// 0x1B 0x5B	
							switch (key[3]) {
								case 0x0:
									c.setUnknown();
									return c;
								case 0x31:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF1();
											return c;
										default:
											c.setUnknown();
											return c;
									}
								case 0x32:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF2();
											return c;
										default:
											c.setUnknown();
											return c;
									}
								case 0x33:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF3();
											return c;
										default:
											c.setUnknown();
											return c;
									}	
								case 0x34:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF4();
											return c;
										default:
											c.setUnknown();
											return c;
									}	
								case 0x35:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF5();
											return c;
										default:
											c.setUnknown();
											return c;
									}	
								case 0x37:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF6();
											return c;
										default:
											c.setUnknown();
											return c;
									}	
								case 0x38:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF7();
											return c;
										default:
											c.setUnknown();
											return c;
									}	
								case 0x39:				// 0x1B 0x5B 0x31
									switch(key[4]) {
										case 0x7E:
											c.setF8();
											return c;
										default:
											c.setUnknown();
											return c;
									}	
								case 0x7E:				// 0x1B 0x5B 0x31
									c.setHome();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						case 0x32:						// 0x1B 0x5B
							switch(key[3]) {
								case 0x0:
									c.setUnknown();
									return c;
								case 0x30:				// 0x1B 0x5B 0x32
									switch (key[4]) {
										case 0x7E:
											c.setF9();
											return c;
										default:
											c.setUnknown();
											return c;
									}
								case 0x31:				// 0x1B 0x5B 0x32
									switch (key[4]) {
										case 0x7E:
											c.setF10();
											return c;
										default:
											c.setUnknown();
											return c;
									}
								case 0x33:				// 0x1B 0x5B 0x32
									switch (key[4]) {
										case 0x7E:
											c.setF11();
											return c;
										default:
											c.setUnknown();
											return c;
									}
								case 0x34:				// 0x1B 0x5B 0x32
									switch (key[4]) {
										case 0x7E:
											c.setF12();
											return c;
										default:
											c.setUnknown();
											return c;
									}
								case 0x7E:				// 0x1B 0x5B 0x32
									c.setIns();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						case 0x33:						// 0x1B 0x5B
							switch (key[3]) {
								case 0x7E:				// 0x1B 0x5B 0x33
									c.setDel();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						case 0x34:						// 0x1B 0x5B
							switch (key[3]) {
								case 0x7E:				// 0x1B 0x5B 0x34
									c.setEnd();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						case 0x35:						// 0x1B 0x5B
							switch (key[3]) {
								case 0x7E:				// 0x1B 0x5B 0x35
									c.setPgUp();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						case 0x36:						// 0x1B 0x5B
							switch (key[3]) {
								case 0x7E:				// 0x1B 0x5B 0x36
									c.setPgDn();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						case 0x41:						// 0x1B 0x5B
							c.setUpArrow();
							return c;
						case 0x42:						// 0x1B 0x5B
							c.setDownArrow();
							return c;
						case 0x43:						// 0x1B 0x5B
							c.setRightArrow();
							return c;
						case 0x44:						// 0x1B 0x5B
							c.setLeftArrow();
							return c;
						case 0x46:						// 0x1B 0x5B
							c.setEnd();
							return c;
						case 0x48:						// 0x1B 0x5B
							c.setHome();
							return c;
						case 0x5B:						// 0x1B 0x5B
							switch (key[3]) {
								case 0x41:				// 0x1B 0x5B 0x5B
									c.setF1();
									return c;
								case 0x42:				// 0x1B 0x5B 0x5B
									c.setF2();
									return c;
								case 0x43:				// 0x1B 0x5B 0x5B
									c.setF3();
									return c;
								case 0x44:				// 0x1B 0x5B 0x5B
									c.setF4();
									return c;
								case 0x45:				// 0x1B 0x5B 0x5B
									c.setF5();
									return c;
								default:
									c.setUnknown();
									return c;
							}
						default:
							c.setUnknown();
							return c;
					}
			}
			if (key[2]==0x0) {
				c=key[1];
				c.setAlt();
				return c;
			}
	}
	if (((key[0] > 0xE0) && (key[0] < 0xFB)) ||
		((key[0] > 0xC0) && (key[0] < 0xDB))) {
		c=key[0]-0x80;
		c.setAlt();
		return c;
	}
	c=key[0];
	return c;
}
